package org.apache.bcel.classfile;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public final class ConstantLong extends Constant implements ConstantObject
{
    private long bytes;
    
    public ConstantLong(final ConstantLong c) {
        this(c.getBytes());
    }
    
    ConstantLong(final DataInput file) throws IOException {
        this(file.readLong());
    }
    
    public ConstantLong(final long bytes) {
        super((byte)5);
        this.bytes = bytes;
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitConstantLong(this);
    }
    
    @Override
    public void dump(final DataOutputStream file) throws IOException {
        file.writeByte(super.getTag());
        file.writeLong(this.bytes);
    }
    
    public long getBytes() {
        return this.bytes;
    }
    
    @Override
    public Object getConstantValue(final ConstantPool cp) {
        return this.bytes;
    }
    
    public void setBytes(final long bytes) {
        this.bytes = bytes;
    }
    
    @Override
    public String toString() {
        return super.toString() + "(bytes = " + this.bytes + ")";
    }
}
